const mysql = require('mysql');

const pool = mysql.createPool({
  host: "49.234.4.249",
  user: "root",
  password: "Al&9TpBTX7gpQ3gs",
  database: 'blog',
  connectionLimit: 20
});


function query ({ sql, args }) {
  return new Promise((resolve, reject) => {
    pool.getConnection((error, connection) => {
      if (error) {
        reject(error.message);
      } else {
        connection.query(sql, args, (error, result) => {
          // 释放链接池
          connection.release();
          if (error) {
            reject(error.message);
          }
          resolve(result);
        });
      }
    });
  });
}

// pool.getConnection((error, connection) => {
//   if (error) {
//     console.log(error)
//   } else {
//     connection.beginTransaction(function (err) {
//       if (err) { throw err; }
//       connection.query("insert into user (user_name,mobile,password) values ('测试名字4', '110','qwer');", [], (error, result) => {
//         if (err) {
//           connection.rollback()
//           connection.release();
//         } else {
//           connection.commit(function (err) {
//             if (!err) {
//               console.log("err")
//               connection.rollback()
//               connection.release();
//             }
//             console.log('success!');
//           })
//         }

//       })
//     })
//   }
// })
// pool.getConnection((error, connection) => {
//   connection.beginTransaction(function (err) {
//     if (err) { throw err; }
//     connection.query("insert into user (user_name,mobile,password) values ('测试名字9', '110','qwer');", function (err, result) {
//       if (err) {
//         return connection.rollback(function () {
//           throw err;
//         });
//       }

//       var log = 'Post ' + result.insertId + ' added';
//       console.log(log)
//       connection.query(`insert into user (user_name,mobile,password) values ('测试名字10', '123','${log}');`, function (err, result) {
//         if (err) {
//           console.log("err--------1")
//           return connection.rollback(function () {
//             throw err;
//           });
//         }


//         connection.commit(function (err) { // 之前可以回滚
//           if (err) {
//             console.log("err--------2")
//             // return connection.rollback(function () {
//             //   throw err;
//             // });
//           }
//           console.log('success!');
//         });
//       });
//     });
//   })
// })

// 一块执行，等两个都resolve 才执行then
const p1 = new Promise((resolve, reject) => {
  resolve("he1")
}).catch(err => err)

const p2 = new Promise((resolve, reject) => {
  reject('hello2');
}).catch(err => err) // Promise 实例，自己定义了catch方法，那么它一旦被rejected，并不会触发Promise.all()的catch 
// p2 也会变成resolved
// 此时 catch的返回传到 then

// try {
//   Promise.all([p1, p2]).then(console.log)
// } catch(err) {
//   console.log(err)
// }

async function test () {
  try {
    let a = await Promise.all([p1, p2]) // resolve的值
    console.log(a)
  } catch (err) {
    console.log(err)
  }
}
test()